<template>

  <Head>
    <title>Report Sales - GreenK Cashier</title>
  </Head>
  <main class="c-main">
    <div class="container-fluid">
      <div class="fade-in">
        <div class="row">
          <div class="col-md-12">
            <div class="card border-0 rounded-3 shadow">
              <div class="card-header bg-primary text-white">
                <span class="font-weight-bold"><i class="fa fa-chart-line me-2"></i> Report Sales</span>
              </div>
              <div class="card-body">
                <form @submit.prevent="filter">
                  <div class="row">
                    <!-- start date -->
                    <div class="col-md-5">
                      <div class="mb-3">
                        <label for="start_date" class="form-label fw-bold">START DATE</label>
                        <input type="date" v-model="start_date" class="form-control" id="start_date">
                      </div>
                      <div v-if="errors.start_date" class="text-danger mb-3" style="margin-top: -15px">
                        <small><strong>{{ errors.start_date }}</strong></small>
                      </div>
                    </div>

                    <!-- end date -->
                    <div class="col-md-5">
                      <div class="mb-3">
                        <label for="end_date" class="form-label fw-bold">END DATE</label>
                        <input type="date" v-model="end_date" class="form-control" id="end-date">
                      </div>
                      <div v-if="errors.end_date" class="text-danger mb-3" style="margin-top: -15px">
                        <small><strong>{{ errors.end_date }}</strong></small>
                      </div>
                    </div>

                    <!-- filter -->
                    <div class="col-md-2">
                      <div class="mb-3">
                        <label class="form-label fw-bold text-white">*</label>
                        <button class="btn btn-md btn-primary border-0 shadow w-100">
                          <i class="fa fa-filter me-2"></i> FILTER
                        </button>
                      </div>
                    </div>
                  </div>
                </form>

                <div v-if="sales">
                  <hr>
                  <!-- button export -->
                  <div class="export text-end mb-3">
                    <!-- export excel -->
                    <a :href="`/apps/sales/export?start_date=${start_date}&end_date=${end_date}`" target="_blank"
                      class="btn btn-success btn-md border-0 shadow me-3"><i class="fa fa-file-excel me-2"></i>
                      EXCEL
                    </a>
                    <!-- export pdf -->
                    <a :href="`/apps/sales/pdf?start_date=${start_date}&end_date=${end_date}`" target="_blank"
                      class="btn bg-pdf btn-md border-0 shadow"><i class="fa fa-file-pdf me-2"></i> 
                      PDF
                    </a>
                  </div>
                  <!-- table of sales -->
                  <div class="table-responsive">
                    <table class="table table-hover">
                      <thead class="bg-primary">
                        <tr>
                          <th scope="col">DATE</th>
                          <th scope="col">INVOICE</th>
                          <th scope="col">CASHIER</th>
                          <th scope="col">CUSTOMER</th>
                          <th scope="col">TOTAL</th>
                        </tr>
                      </thead>
                      <tbody>
                        <tr v-for="sale in sales" :key="sale.id">
                          <td>{{ sale.created_at }}</td>
                          <td>{{ sale.invoice }}</td>
                          <td>{{ sale.cashier.name }}</td>
                          <td>{{ sale.customer ? sale.customer.name : 'Someone' }}</td>
                          <td>Rp {{ formatPrice(sale.grand_total) }}</td>
                        </tr>
                        <tr>
                          <td colspan="4" class="text-center fw-bold bg-primary text-white">TOTAL</td>
                          <td class="fw-bold bg-primary text-white">Rp {{ formatPrice(total) }}</td>
                        </tr>
                      </tbody>
                    </table>
                  </div>
                </div>
                <!-- pagination -->
                <!-- <Pagination :links="customers.links" align="end" /> -->
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </main>
</template>

<script>
// import layout
import LayoutApp from '../../../Layouts/App.vue'

// import Head and Link 
import { Head, Link } from '@inertiajs/vue3'

// import ref from vue
import { ref } from 'vue'

// import router adapter inertia
import { router } from '@inertiajs/vue3'

export default {
  // layout app
  layout: LayoutApp,

  // register components
  components: {
    Head,
    Link
  },

  // props
  props: {
    errors: Object,
    sales: Array,
    total: Number,
  },

  // compostion api
  setup(props) {
    // define state
    const start_date = ref('' || (new URL(document.location)).searchParams.get('start_date'));
    const end_date = ref('' || (new URL(document.location)).searchParams.get('end_date'));

    // define method filter
    const filter = () => {
      // http request
      router.get('/apps/sales/filter', {
        // send data to server
        start_date: start_date.value,
        end_date: end_date.value,
      });
    }

    return {
      start_date,
      end_date,
      filter,
    }
  }

}
</script>